#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum SortField {
    #[serde(rename = "START_TIME")]
    StartTime,
    #[serde(rename = "END_TIME")]
    EndTime,
    #[serde(rename = "DURATION")]
    Duration,
    #[serde(rename = "DISPOSITION_STATUS")]
    DispositionStatus,
    #[serde(rename = "PRIORITY")]
    Priority,
    #[serde(rename = "EVENT_NAME")]
    EventName,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl SortField {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            SortField::StartTime => "START_TIME",
            SortField::EndTime => "END_TIME",
            SortField::Duration => "DURATION",
            SortField::DispositionStatus => "DISPOSITION_STATUS",
            SortField::Priority => "PRIORITY",
            SortField::EventName => "EVENT_NAME",
            SortField::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for SortField {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for SortField {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for SortField {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(v: &str) -> Result<SortField, conjure_object::plain::ParseEnumError> {
        match v {
            "START_TIME" => Ok(SortField::StartTime),
            "END_TIME" => Ok(SortField::EndTime),
            "DURATION" => Ok(SortField::Duration),
            "DISPOSITION_STATUS" => Ok(SortField::DispositionStatus),
            "PRIORITY" => Ok(SortField::Priority),
            "EVENT_NAME" => Ok(SortField::EventName),
            v => v.parse().map(|v| SortField::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for SortField {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(v: &str) -> Result<SortField, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the SortField enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
